from ngsolve import *
from ngsolve.meshes import MakeStructured3DMesh
ngsglobals.msg_level=0

mesh = MakeStructured3DMesh(hexes=False, nx=1, ny=1, nz=1)
nref = 4
for i in range(nref):
   for el in mesh.Elements():
       if el.nr ==0:
           mesh.SetRefinementFlag(el, True)
       else:
           mesh.SetRefinementFlag(el, False)
   mesh.Refine()
   print("Level: ", i, "#Nodes: ", mesh.nv)

# the parent vertices of last new vertex
print(mesh.GetParentVertices(81))



